var tokens = [
	{ t:'atom', re:/^(true|false|null)/ },
	{ t:'number', re:/^-?(0|[1-9][0-9]*)(\.[0-9]+)?([eE][-+]?[0-9]+)?/ },
	{ t:'string', re:/^"(\\"|[^"])*"/ },
	{ t:'{', re:/^{/ },
	{ t:'}', re:/^}/ },
	{ t:'[', re:/^\[/ },
	{ t:']', re:/^\]/ },
	{ t:',', re:/^,/ },
	{ t:':', re:/^:/ },
	{ t:'whitespace', re:/\s*/ }
];

var firstMatch = function(text, pointer) {
	for (var i = 0; i < tokens.length; i++) {
		var match = tokens[i].re.exec(text);
		if (match) {
			return { type:tokens[i].t, text:match[0], position:pointer }
		}
	}
	throw 'unrecognizable token at position ' + pointer;
}

exports.scanText = function(text) {
	var tokenList = [];
	var pointer = 0;
	while (pointer < text.length) {
		var match = firstMatch(text.substring(pointer), pointer);
		if (match.type !== 'whitespace') {
			tokenList.push(match);
		}
		pointer += match.text.length;
	}
	return tokenList;
};